#ifndef __TIME_MANAGER_HPP__
#define __TIME_MANAGER_HPP__

/**
 * Time_manager class : gives a class to synchronise the FPS of the program
 * @author Alexandre LAURENT
 */
class Time_manager
{
	private :
	
		long unsigned int start_time;
		unsigned int time_counter;
		unsigned int frame_counter;
		unsigned int waiting_time;
		
		long unsigned int getMicroSecond();			///< gets the number of microseconds
		long unsigned int getSecond();	///< gets the number of seconds

	public :
	
		Time_manager(unsigned int nbFPSperSecond);

		void waitForFPS();	///< Waits to synchronise the FPS number 
		void countFPS();	///< Shows the number of FPS
};

#endif
